## deepin-system-monitor 6.0.23

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

if (NOT DEFINED VERSION)
    set(VERSION 5.9.1000)
endif()

project(deepin_system_monitor_proj)

option(DOTEST "option for test" OFF)

# 是否开启单元测试编译
#set(DOTEST ON)

include(GNUInstallDirs)
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set(CMAKE_INSTALL_PREFIX /usr)
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")
  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")
  add_definitions("-DQT_NO_WARNING_OUTPUT")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,--gc-sections")
endif()

#判断龙芯架构
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    SET(IS_LOONGARCH_TYPE 1)
elseif(${CMAKE_HOST_SYSTEM_PROCESSOR} MATCHES "__longarch64")
    SET(NOT_LOONGARCH_TYPE )
else()
    SET(IS_LOONGARCH_TYPE 0)
endif()

#系统监视器主应用
ADD_SUBDIRECTORY(deepin-system-monitor-main)
#系统监视器插件
ADD_SUBDIRECTORY(deepin-system-monitor-plugin)
#系统监视器插件弹出应用
ADD_SUBDIRECTORY(deepin-system-monitor-plugin-popup)
#系统监视器安全等级保护守护应用
ADD_SUBDIRECTORY(deepin-system-monitor-daemon)
#系统监视器提示
ADD_SUBDIRECTORY(deepin-system-monitor-server)
#系统监视器后端提权处理服务
ADD_SUBDIRECTORY(deepin-system-monitor-system-server)

#单元测试
if(DOTEST)
    ADD_SUBDIRECTORY(tests)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/config.h)

#安装日志收集工具配置
set(journel_system_monitor_main assets/logconfig/org.deepin.system-monitor.json)
install(FILES ${journel_system_monitor_main} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-log-viewer/deepin-log.conf.d/)

#安装DConfig配置
set(APPID org.deepin.system-monitor)
set(system_monitor_main assets/configs/org.deepin.system-monitor.json)
set(system_monitor_daemon assets/configs/org.deepin.system-monitor.daemon.json)
set(system_monitor_plugin assets/configs/org.deepin.system-monitor.plugin.json)
set(system_monitor_plugin_popup assets/configs/org.deepin.system-monitor.plugin.popup.json)
set(system_monitor_plugin_server assets/configs/org.deepin.system-monitor.server.json)

if (DEFINED DSG_DATA_DIR)
    dconfig_meta_files(APPID ${APPID} FILES ${system_monitor_main})
    dconfig_meta_files(APPID ${APPID} FILES ${system_monitor_daemon})
    dconfig_meta_files(APPID ${APPID} FILES ${system_monitor_plugin})
    dconfig_meta_files(APPID ${APPID} FILES ${system_monitor_plugin_popup})
    dconfig_meta_files(APPID ${APPID} FILES ${system_monitor_plugin_server})
    message("-- DConfig is supported by DTK")
else()
    install(FILES ${system_monitor_main} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/configs/${APPID}/)
    install(FILES ${system_monitor_daemon} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/configs/${APPID}/)
    install(FILES ${system_monitor_plugin} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/configs/${APPID}/)
    install(FILES ${system_monitor_plugin_popup} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/configs/${APPID}/)
    install(FILES ${system_monitor_plugin_server} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/configs/${APPID}/)

    message("-- DConfig is not supported by DTK")
endif()

=== deepin-system-monitor-daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

set(PROJECT_NAME deepin-system-monitor)
set(BIN_NAME ${PROJECT_NAME}-daemon)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

# 设置包含头文件的时候不用包含路径 begin ****************************************************************************************
MACRO(SUBDIRLIST result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*)
  SET(dirlist "")
  FOREACH(child ${children})
    IF(IS_DIRECTORY ${curdir}/${child})
      LIST(APPEND dirlist ${child})
    ENDIF()
  ENDFOREACH()
  SET(${result} ${dirlist})
ENDMACRO()
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
SUBDIRLIST(dirs ${CMAKE_CURRENT_SOURCE_DIR}/src)
foreach(dir ${dirs})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/${dir})
endforeach()
# 设置包含头文件的时候不用包含路径 end ****************************************************************************************

file(GLOB_RECURSE SRC_CPP ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE SRC_H ${CMAKE_CURRENT_LIST_DIR}/src/*.h)

find_package(Qt5 COMPONENTS Core DBus REQUIRED)
find_package(DtkCore CONFIG REQUIRED)

qt5_add_resources(RESOURCES_FILE assets/${BIN_NAME}.qrc)

add_library(${BIN_NAME} MODULE
    ${SRC_CPP}
    ${SRC_H}
    ${RESOURCES_FILE}
)

target_include_directories(${BIN_NAME} PUBLIC
  Qt5::Core
  Qt5::DBus
  ${DtkCore_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt5::Core
  Qt5::DBus
  ${DtkCore_LIBRARIES}
)

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wl,-Map=deepin-system-monitor-daemon.map")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wl,-Map=deepin-system-monitor-daemon.map")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/user/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/${BIN_NAME}.json ${CMAKE_BINARY_DIR}/share/system/)
else()
    install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
    install(FILES ${BIN_NAME}.json DESTINATION share/deepin-service-manager/user/)
endif()

=== deepin-system-monitor-main/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

project(deepin-system-monitor)

option(USE_DEEPIN_WAYLAND "option for wayland support" ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(APP_RES_ROOT assets)
set(APP_RESOURCES ${APP_RES_ROOT}/${PROJECT_NAME}.qrc)
set(DESKTOP_FILE ${PROJECT_NAME}.desktop)
set(POLICY_FILE com.deepin.pkexec.${PROJECT_NAME}.policy)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "Release")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()
if (USE_DEEPIN_WAYLAND)
  add_definitions("-DUSE_DEEPIN_WAYLAND")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/environments.h.in ${CMAKE_CURRENT_BINARY_DIR}/environments.h @ONLY)

include(CheckIncludeFiles)
check_include_files ("sys/random.h" HAVE_SYS_RANDOM_H)
include(CheckSymbolExists)
check_symbol_exists(syscall "unistd.h" HAVE_SYS_CALL)
check_symbol_exists(SYS_getrandom "sys/syscall.h" HAVE_SYS_GETRANDOM)
include(FindPkgConfig)
if (USE_DEEPIN_WAYLAND)
    find_package(DWayland)
    find_package(KF5Wayland)
    if (DWayland_FOUND)
        message("DWayland founded.")
        add_definitions(-DDWAYLAND)
    elseif(KF5Wayland_FOUND)
        message("KF5Wayland founded.")
        add_definitions(-DKF5WAYLAND)
    endif()
endif()

find_package(Qt5 COMPONENTS Core REQUIRED)
find_package(Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Gui REQUIRED)
find_package(Qt5 COMPONENTS X11Extras REQUIRED)
find_package(Qt5 COMPONENTS DBus REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS LinguistTools REQUIRED)

find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)
find_library(LIB_PCAP NAMES pcap REQUIRED)
find_library(LIB_XCB NAMES xcb REQUIRED)
find_library(LIB_XEXT NAMES Xext REQUIRED)
find_library(LIB_ICCCM NAMES xcb-icccm REQUIRED)
find_package(ICU COMPONENTS i18n uc REQUIRED)

#pkg_search_module(DFrameworkDBus REQUIRED dframeworkdbus)  # chinalife
pkg_search_module(LIB_NL3 REQUIRED libnl-3.0)
pkg_search_module(LIB_NL3_ROUTE REQUIRED libnl-route-3.0)
pkg_search_module(LIB_UDEV REQUIRED libudev)
include_directories(${DtkCore_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkWidget_INCLUDE_DIRS})

include_directories(${LIB_NL3_INCLUDE_DIRS})
include_directories(${LIB_NL3_ROUTE_INCLUDE_DIRS})
include_directories(${LIB_UDEV_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/3rdparty)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libsmartcols/src)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)
#include_directories(${DFrameworkDBus_INCLUDE_DIRS})  # chinalife

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wl,-Map=deepin-system-monitor-main.map")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wl,-Map=deepin-system-monitor-main.map")

set(HPP_GLOBAL
    environments.h
    accessible.h
    accessibledefine.h
    application.h
    stack_trace.h
    cpu_monitor.h
    memory_monitor.h
    network_monitor.h
    compact_cpu_monitor.h
    compact_memory_monitor.h
    compact_network_monitor.h
    compact_disk_monitor.h
    smooth_curve_generator.h
    settings.h
    detailwidgetmanager.h
    logger.h
    ddlog.h
)
set(CPP_GLOBAL
    main.cpp
    application.cpp
    cpu_monitor.cpp
    memory_monitor.cpp
    network_monitor.cpp
    compact_cpu_monitor.cpp
    compact_memory_monitor.cpp
    compact_network_monitor.cpp
    compact_disk_monitor.cpp
    smooth_curve_generator.cpp
    settings.cpp
    detailwidgetmanager.cpp
    logger.cpp
)

set(HPP_COMMON
    common/common.h
    common/error_context.h
    common/hash.h
    common/han_latin.h
    common/perf.h
    common/base_thread.h
    common/thread_manager.h
    common/time_period.h
    common/sample.h
    common/eventlogutils.h
)
set(CPP_COMMON
    common/common.cpp
    common/error_context.cpp
    common/hash.cpp
    common/han_latin.cpp
    common/perf.cpp
    common/thread_manager.cpp
    common/time_period.cpp
    common/eventlogutils.cpp
)

set(HPP_DBUS
    dbus/systemd1_manager_interface.h
    dbus/systemd1_service_interface.h
    dbus/systemd1_unit_interface.h
    dbus/dbus_properties_interface.h
    dbus/dbus_common.h
    dbus/environment_file.h
    dbus/unit_file_info.h
    dbus/unit_info.h
    dbus/dbusforsystemomonitorpluginservce.h
    dbus/dbus_object.h
    dbus/dbusalarmnotify.h
)
set(CPP_DBUS
    dbus/environment_file.cpp
    dbus/unit_file_info.cpp
    dbus/unit_info.cpp
    dbus/systemd1_manager_interface.cpp
    dbus/systemd1_service_interface.cpp
    dbus/systemd1_unit_interface.cpp
    dbus/dbus_properties_interface.cpp
    dbus/dbusforsystemomonitorpluginservce.cpp
    dbus/dbus_object.cpp
    dbus/dbusalarmnotify.cpp
)

set(HPP_MODEL
    model/process_table_model.h
    model/process_sort_filter_proxy_model.h
    model/system_service_table_model.h
    model/system_service_sort_filter_proxy_model.h
    model/cpu_info_model.h
    model/cpu_stat_model.h
    model/cpu_list_model.h
    model/cpu_list_sort_filter_proxy_model.h
    model/netif_info_model.h
    model/netif_stat_model.h
    model/netif_addr_model.h
    model/netif_info_sort_filter_proxy_model.h
    model/block_dev_stat_model.h
    model/block_dev_info_model.h
    model/block_dev_info_sort_filter_proxy_model.h
    model/model_manager.h
    model/accounts_info_model.h
    model/user.h

)
set(CPP_MODEL
    model/system_service_table_model.cpp
    model/system_service_sort_filter_proxy_model.cpp
    model/process_table_model.cpp
    model/process_sort_filter_proxy_model.cpp
    model/cpu_info_model.cpp
    model/cpu_stat_model.cpp
    model/cpu_list_model.cpp
    model/cpu_list_sort_filter_proxy_model.cpp
    model/netif_info_model.cpp
    model/netif_stat_model.cpp
    model/netif_addr_model.cpp
    model/netif_info_sort_filter_proxy_model.cpp
    model/block_dev_info_model.cpp
    model/block_dev_stat_model.cpp
    model/block_dev_info_sort_filter_proxy_model.cpp
    model/model_manager.cpp
    model/accounts_info_model.cpp
    model/user.cpp
)

set(HPP_GUI
    gui/base/base_detail_item_delegate.h
    gui/base/base_table_view.h
    gui/base/base_item_delegate.h
    gui/base/base_header_view.h
    gui/base/base_detail_view_widget.h
    gui/base/base_commandlink_button.h
    gui/ui_common.h
    gui/toolbar.h
    gui/main_window.h
    gui/process_table_view.h
    gui/process_page_widget.h
    gui/service_name_sub_input_dialog.h
    gui/system_service_table_view.h
    gui/system_service_page_widget.h
    gui/monitor_expand_view.h
    gui/monitor_compact_view.h
    gui/priority_slider.h
    gui/kill_process_confirm_dialog.h
    gui/process_attribute_dialog.h
    gui/dialog/error_dialog.h
    gui/xwin_kill_preview_widget.h
    gui/xwin_kill_preview_background_widget.h
    gui/mem_detail_view_widget.h
    gui/mem_summary_view_widget.h
    gui/mem_stat_view_widget.h
    gui/block_dev_detail_view_widget.h
    gui/block_dev_summary_view_widget.h
    gui/netif_detail_view_widget.h
    gui/netif_stat_view_widget.h
    gui/netif_item_view_widget.h
    gui/netif_summary_view_widget.h
    gui/detail_view_stacked_widget.h
    gui/chart_view_widget.h
    gui/block_dev_stat_view_widget.h
    gui/animation_stackedwidget.h
    gui/cpu_detail_widget.h
    gui/cpu_summary_view_widget.h
    gui/block_dev_item_widget.h
    gui/dialog/systemprotectionsetting.h
    gui/dialog/custombuttonbox.h
    gui/user_page_widget.h
    gui/accounts_widget.h
    gui/onlineicon.h
    gui/user_list_view.h
)
set(CPP_GUI
    gui/base/base_detail_item_delegate.cpp
    gui/base/base_table_view.cpp
    gui/base/base_item_delegate.cpp
    gui/base/base_header_view.cpp
    gui/base/base_detail_view_widget.cpp
    gui/base/base_commandlink_button.cpp
    gui/toolbar.cpp
    gui/system_service_table_view.cpp
    gui/main_window.cpp
    gui/system_service_page_widget.cpp
    gui/process_page_widget.cpp
    gui/service_name_sub_input_dialog.cpp
    gui/process_table_view.cpp
    gui/dialog/error_dialog.cpp
    gui/monitor_expand_view.cpp
    gui/monitor_compact_view.cpp
    gui/kill_process_confirm_dialog.cpp
    gui/process_attribute_dialog.cpp
    gui/priority_slider.cpp
    gui/ui_common.cpp
    gui/xwin_kill_preview_widget.cpp
    gui/xwin_kill_preview_background_widget.cpp
    gui/mem_detail_view_widget.cpp
    gui/mem_summary_view_widget.cpp
    gui/mem_stat_view_widget.cpp
    gui/block_dev_detail_view_widget.cpp
    gui/block_dev_summary_view_widget.cpp
    gui/netif_detail_view_widget.cpp
    gui/netif_summary_view_widget.cpp
    gui/netif_stat_view_widget.cpp
    gui/netif_item_view_widget.cpp
    gui/detail_view_stacked_widget.cpp
    gui/chart_view_widget.cpp
    gui/animation_stackedwidget.cpp
    gui/cpu_detail_widget.cpp
    gui/cpu_summary_view_widget.cpp
    gui/block_dev_item_widget.cpp
    gui/block_dev_stat_view_widget.cpp
    gui/dialog/systemprotectionsetting.cpp
    gui/dialog/settingsdialog.cpp
    gui/dialog/custombuttonbox.cpp
    gui/user_page_widget.cpp
    gui/accounts_widget.cpp
    gui/onlineicon.cpp
    gui/user_list_view.cpp
)

set(HPP_PROCESS
    process/private/process_p.h
    process/process.h
    process/process_set.h
    process/process_icon.h
    process/process_icon_cache.h
    process/process_name.h
    process/process_name_cache.h
    process/priority_controller.h
    process/process_controller.h
    process/desktop_entry_cache.h
    process/desktop_entry_cache_updater.h
    process/process_db.h
)
set(CPP_PROCESS
    process/process.cpp
    process/process_set.cpp
    process/process_icon.cpp
    process/process_icon_cache.cpp
    process/process_name.cpp
    process/process_name_cache.cpp
    process/priority_controller.cpp
    process/process_controller.cpp
    process/desktop_entry_cache.cpp
    process/desktop_entry_cache_updater.cpp
    process/process_db.cpp
)

set(HPP_SERVICE
    service/service_manager_worker.h
    service/service_manager.h
    service/system_service_entry_data.h
    service/system_service_entry.h
)
set(CPP_SERVICE
    service/service_manager_worker.cpp
    service/service_manager.cpp
    service/system_service_entry_data.cpp
    service/system_service_entry.cpp
)

set(HPP_SYSTEM
    system/private/mem_p.h
    system/private/cpu_p.h
    system/private/cpu_set_p.h
    system/private/block_device_p.h
    system/private/netif_p.h
    system/private/sys_info_p.h
    system/system_monitor.h
    system/system_monitor_thread.h
    system/device_id_cache.h
    system/packet.h
    system/netif.h
    system/netif_info_db.h
    system/netif_monitor.h
    system/netif_monitor_thread.h
    system/netif_packet_capture.h
    system/netif_packet_parser.h
    system/mem.h
    system/cpu.h
    system/cpu_set.h
    system/block_device.h
    system/block_device_info_db.h
    system/device_db.h
    system/sys_info.h
    system/udev.h
    system/udev_device.h
    system/netlink.h
    system/nl_addr.h
    system/nl_hwaddr.h
    system/nl_link.h
    system/wireless.h
    system/diskio_info.h
    system/net_info.h
)
set(CPP_SYSTEM
    system/system_monitor.cpp
    system/system_monitor_thread.cpp
    system/device_id_cache.cpp
    system/netif_monitor.cpp
    system/netif_monitor_thread.cpp
    system/netif_packet_capture.cpp
    system/netif_packet_parser.cpp
    system/device_db.cpp
    system/netif.cpp
    system/netif_info_db.cpp
    system/mem.cpp
    system/cpu.cpp
    system/cpu_set.cpp

=== deepin-system-monitor-plugin-popup/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

project(deepin-system-monitor-plugin-popup LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(APP_RES_ROOT asserts)
set(APP_RESOURCES ${APP_RES_ROOT}/${PROJECT_NAME}.qrc)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

set(MAIN_APP_DIR ${CMAKE_SOURCE_DIR}/deepin-system-monitor-main)

if(CMAKE_BUILD_TYPE STREQUAL "Release")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/environments.h.in ${CMAKE_CURRENT_BINARY_DIR}/environments.h @ONLY)

include(CheckIncludeFiles)
check_include_files("sys/random.h" HAVE_SYS_RANDOM_H)
include(CheckSymbolExists)
check_symbol_exists(syscall "unistd.h" HAVE_SYS_CALL)
check_symbol_exists(SYS_getrandom "sys/syscall.h" HAVE_SYS_CALL)
include(FindPkgConfig)

find_package(Qt5 COMPONENTS Core REQUIRED)
find_package(Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Gui REQUIRED)
find_package(Qt5 COMPONENTS X11Extras REQUIRED)
find_package(Qt5 COMPONENTS DBus REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS LinguistTools REQUIRED)

find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(Qt5Svg REQUIRED)
find_library(LIB_XCB NAMES xcb REQUIRED)
find_library(LIB_XEXT NAMES Xext REQUIRED)
find_library(LIB_ICCCM NAMES xcb-icccm REQUIRED)
find_package(ICU COMPONENTS i18n uc REQUIRED)

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wl,-Map=deepin-system-monitor-pluign-popup.map")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wl,-Map=deepin-system-monitor-popup.map")
#pkg_check_modules(QGSettings REQUIRED gsettings-qt)

#pkg_check_modules(DdeDockInterface REQUIRED dde-dock)

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")

pkg_search_module(LIB_NL3 REQUIRED libnl-3.0)
pkg_search_module(LIB_NL3_ROUTE REQUIRED libnl-route-3.0)
pkg_search_module(LIB_UDEV REQUIRED libudev)
include_directories(${LIB_NL3_INCLUDE_DIRS})
include_directories(${LIB_NL3_ROUTE_INCLUDE_DIRS})
include_directories(${LIB_UDEV_INCLUDE_DIRS})

#include_directories(${QGSettings_INCLUDE_DIRS})

include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})
include_directories(${MAIN_APP_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

FILE(GLOB_RECURSE SRCS "*.h" "*.cpp")

SET(HPP_MODEL
    ${MAIN_APP_DIR}/model/cpu_info_model.h
    ${MAIN_APP_DIR}/model/cpu_stat_model.h
    ${MAIN_APP_DIR}/model/cpu_list_model.h
    model/process_sort_filter_proxy_model.h
    model/process_table_model.h
)

SET(CPP_MODEL
    ${MAIN_APP_DIR}/model/cpu_info_model.cpp
    ${MAIN_APP_DIR}/model/cpu_stat_model.cpp
    ${MAIN_APP_DIR}/model/cpu_list_model.cpp
    model/process_sort_filter_proxy_model.cpp
    model/process_table_model.cpp
)

SET(HPP_GLOBAL
    common/datacommon.h
    ${MAIN_APP_DIR}/common/common.h
    common/utils.h
    ${MAIN_APP_DIR}/common/hash.h
    ${MAIN_APP_DIR}/common/sample.h
    ${MAIN_APP_DIR}/stack_trace.h
    ${MAIN_APP_DIR}/common/thread_manager.h
    ${MAIN_APP_DIR}/common/time_period.h
    ${MAIN_APP_DIR}/common/base_thread.h
    ${MAIN_APP_DIR}/common/error_context.h
    ${MAIN_APP_DIR}/common/han_latin.h
    ${MAIN_APP_DIR}/settings.h
    ${MAIN_APP_DIR}/common/perf.h
)

SET(CPP_GLOBAL
    common/utils.cpp
    ${MAIN_APP_DIR}/common/hash.cpp
    ${MAIN_APP_DIR}/common/common.cpp
    ${MAIN_APP_DIR}/common/thread_manager.cpp
    ${MAIN_APP_DIR}/common/time_period.cpp
    ${MAIN_APP_DIR}/common/error_context.cpp
    ${MAIN_APP_DIR}/common/han_latin.cpp
    ${MAIN_APP_DIR}/settings.cpp
    ${MAIN_APP_DIR}/common/perf.cpp
)

SET(HPP_SYSTEM
    ${MAIN_APP_DIR}/system/private/cpu_p.h
    ${MAIN_APP_DIR}/system/private/cpu_set_p.h
    ${MAIN_APP_DIR}/system/private/mem_p.h
    ${MAIN_APP_DIR}/system/private/sys_info_p.h
    ${MAIN_APP_DIR}/system/private/block_device_p.h
    ${MAIN_APP_DIR}/system/diskio_info.h
    system/cpu_set.h
    ${MAIN_APP_DIR}/system/cpu.h
    system/device_db.h
    ${MAIN_APP_DIR}/system/mem.h
    ${MAIN_APP_DIR}/system/net_info.h
    ${MAIN_APP_DIR}/system/packet.h
    ${MAIN_APP_DIR}/system/sys_info.h

    ${MAIN_APP_DIR}/system/system_monitor_thread.h
    ${MAIN_APP_DIR}/system/system_monitor.h
    ${MAIN_APP_DIR}/system/block_device_info_db.h
    ${MAIN_APP_DIR}/system/block_device.h
)

SET(CPP_SYSTEM
    ${MAIN_APP_DIR}/system/diskio_info.cpp
    system/cpu_set.cpp
    ${MAIN_APP_DIR}/system/cpu.cpp
    system/device_db.cpp
    ${MAIN_APP_DIR}/system/mem.cpp
    ${MAIN_APP_DIR}/system/net_info.cpp
    ${MAIN_APP_DIR}/system/sys_info.cpp
    ${MAIN_APP_DIR}/system/system_monitor_thread.cpp
    ${MAIN_APP_DIR}/system/system_monitor.cpp
    ${MAIN_APP_DIR}/system/block_device_info_db.cpp
    ${MAIN_APP_DIR}/system/block_device.cpp
)

SET(HPP_GUI
    gui/base/base_table_view.h
    ${MAIN_APP_DIR}/gui/base/base_header_view.h
    gui/base/base_item_delegate.h
    gui/mainwindow.h
    gui/datadealsingleton.h
    gui/process_table_view.h
    ${MAIN_APP_DIR}/gui/ui_common.h
    gui/cpu_widget.h
    gui/disk_widget.h
    gui/memory_widget.h
    gui/net_widget.h
    gui/process_widget.h
)


SET(CPP_GUI
    gui/base/base_table_view.cpp
    ${MAIN_APP_DIR}/gui/base/base_header_view.cpp
    gui/base/base_item_delegate.cpp
    gui/mainwindow.cpp
    gui/datadealsingleton.cpp
    gui/process_table_view.cpp
    ${MAIN_APP_DIR}/gui/ui_common.cpp
    gui/cpu_widget.cpp
    gui/disk_widget.cpp
    gui/memory_widget.cpp
    gui/net_widget.cpp
    gui/process_widget.cpp
)


SET(HPP_WM
    ${MAIN_APP_DIR}/wm/wm_window_list.h
    ${MAIN_APP_DIR}/wm/wm_atom.h
    ${MAIN_APP_DIR}/wm/wm_connection.h
    ${MAIN_APP_DIR}/wm/wm_info.h
    ${MAIN_APP_DIR}/wm/wm_window_tree.h
)

SET(CPP_WM
    ${MAIN_APP_DIR}/wm/wm_window_list.cpp
    ${MAIN_APP_DIR}/wm/wm_atom.cpp
    ${MAIN_APP_DIR}/wm/wm_connection.cpp
    ${MAIN_APP_DIR}/wm/wm_info.cpp
    ${MAIN_APP_DIR}/wm/wm_window_tree.cpp
)

SET(HPP_DBUS
    dbus/systemmonitordbusadaptor.h
    dbus/dbusdockinterface.h
    dbus/dbuscallmaininterface.h
    dbus/dbusayatanainterface.h
)

SET(CPP_DBUS
    dbus/systemmonitordbusadaptor.cpp
    dbus/dbusdockinterface.cpp
    dbus/dbuscallmaininterface.cpp
    dbus/dbusayatanainterface.cpp
)

SET(HPP_PROCESS
    ${MAIN_APP_DIR}/process/private/process_p.h
    ${MAIN_APP_DIR}/process/process_icon_cache.h
    ${MAIN_APP_DIR}/process/process_set.h
    process/process.h
    process/process_db.h
    ${MAIN_APP_DIR}/process/process_icon.h
    ${MAIN_APP_DIR}/process/desktop_entry_cache.h
    ${MAIN_APP_DIR}/process/desktop_entry_cache_updater.h
    ${MAIN_APP_DIR}/process/process_name.h
    ${MAIN_APP_DIR}/process/process_name_cache.h
    ${MAIN_APP_DIR}/process/process_controller.h
)

SET(CPP_PROCESS
    ${MAIN_APP_DIR}/process/process_icon_cache.cpp
    ${MAIN_APP_DIR}/process/process_set.cpp
    process/process.cpp
    process/process_db.cpp
    ${MAIN_APP_DIR}/process/process_icon.cpp
    ${MAIN_APP_DIR}/process/desktop_entry_cache.cpp
    ${MAIN_APP_DIR}/process/desktop_entry_cache_updater.cpp
    ${MAIN_APP_DIR}/process/process_name.cpp
    ${MAIN_APP_DIR}/process/process_name_cache.cpp
    ${MAIN_APP_DIR}/process/process_controller.cpp
)
set(APP_HPP
    ${CMAKE_HOME_DIRECTORY}/config.h
    application.h
    ddlog.h
    logger.h
    ${HPP_MODEL}
    ${HPP_SYSTEM}
    ${HPP_GLOBAL}
    ${HPP_GUI}
    ${HPP_DBUS}
    ${HPP_PROCESS}
    ${HPP_WM}
)

set(APP_CPP
    application.cpp
    main.cpp
    logger.cpp
    ${CPP_MODEL}
    ${CPP_SYSTEM}
    ${CPP_GLOBAL}
    ${CPP_GUI}
    ${CPP_DBUS}
    ${CPP_PROCESS}
    ${CPP_WM}
)

add_executable(${PROJECT_NAME}
    ${APP_HPP}
    ${APP_CPP}
    ${PROJECT_SOURCE_DIR}/${APP_RESOURCES}    
)

target_include_directories(${PROJECT_NAME} PUBLIC
#    ${Qt5Widgets_INCLUDE_DIRS}
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkCore_INCLUDE_DIRS}
    ${DtkGui_INCLUDE_DIRS}
    ${DdeDockInterface_INCLUDE_DIRS}
    Dtk::Core
)
target_link_libraries(${PROJECT_NAME}
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    Qt5::Concurrent
    Qt5::X11Extras
    Qt5::Svg
    dtkcore
    dtkwidget
    dtkgui
    ICU::i18n
    ICU::uc
    ${LIB_XCB}
    ${LIB_XEXT}
    ${LIB_ICCCM}
    ${LIB_NL3_LIBRARIES}
    ${LIB_NL3_ROUTE_LIBRAIES}
    ${LIB_UDEV_LIBRARIES}
    ${LIB_DDEDOCK}
#    gsettings-qt
    Dtk::Core
)


#生成qm
file(GLOB APP_TS_FILES LIST_DIRECTORIES false translations/*.ts)
qt5_add_translation(APP_QM_FILES ${APP_TS_FILES})
add_custom_target(POPUP_QMFILES ALL DEPENDS ${APP_QM_FILES})

#
install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.deepin.SystemMonitorPluginPopup.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)
#install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/deepin-system-monitor-plugin-popup.desktop DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart)
#安装翻译文件
install(FILES ${APP_QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-system-monitor-plugin-popup/translations)

=== deepin-system-monitor-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

project(deepin-system-monitor-plugin LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt5 COMPONENTS Core REQUIRED)
find_package(Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Gui REQUIRED)
find_package(Qt5 COMPONENTS X11Extras REQUIRED)
find_package(Qt5 COMPONENTS DBus REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS LinguistTools REQUIRED)

set(APP_RES_ROOT asserts)
set(APP_RESOURCES ${APP_RES_ROOT}/${PROJECT_NAME}.qrc)

# Sources files
file(GLOB SRCS "*.h" "*.cpp" "gui/*.h" "gui/*.cpp" "dbus/*.h" "dbus/*.cpp")

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DdeDockInterface REQUIRED dde-dock)

if (DdeDockInterface_FOUND)
    message("dde-dock founded: ${DdeDockInterface_VERSION}")
    string(REGEX MATCH "^[0-9]" VERSION_MAJOR ${DdeDockInterface_VERSION})
    if (VERSION_MAJOR STREQUAL "6" OR VERSION_MAJOR STRGREATER "6")
        add_definitions(-DDDE_DOCK_MAJORV6)
    endif()
endif()

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PROJECT_NAME} SHARED ${SRCS} ${APP_RESOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)

include_directories(${DtkCore_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

target_include_directories(${PROJECT_NAME} PUBLIC
  ${DdeDockInterface_INCLUDE_DIRS}
  ${DtkWidget_INCLUDE_DIRS}
  ${QGSettings_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
  ${Qt5DBus_LIBRARIES}
  ${DtkWidget_LIBRARIES}
  ${Qt5Widgets_LIBRARIES}
  ${Qt5Svg_LIBRARIES}
  ${QGSettings_LIBRARIES}
)

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wl,-Map=deepin-system-monitor-plugin.map")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wl,-Map=deepin-system-monitor-plugin.map")

#生成qm
file(GLOB APP_TS_FILES LIST_DIRECTORIES false translations/*.ts)
qt5_add_translation(APP_QM_FILES ${APP_TS_FILES})
add_custom_target(PLUGIN_QMFILES ALL DEPENDS ${APP_QM_FILES})

INSTALL(FILES com.deepin.dde.dock.module.system-monitor.gschema.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)
#INSTALL(FILES com.deepin.system.monitor.plugin.gschema.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)
INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)
#安装翻译文件
install(FILES ${APP_QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-system-monitor-plugin/translations)

=== deepin-system-monitor-server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(BIN_NAME deepin-system-monitor-server)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

# 设置包含头文件的时候不用包含路径 begin ****************************************************************************************
MACRO(SUBDIRLIST result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*)
  SET(dirlist "")
  FOREACH(child ${children})
    IF(IS_DIRECTORY ${curdir}/${child})
      LIST(APPEND dirlist ${child})
    ENDIF()
  ENDFOREACH()
  SET(${result} ${dirlist})
ENDMACRO()
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
SUBDIRLIST(dirs ${CMAKE_CURRENT_SOURCE_DIR}/src)
foreach(dir ${dirs})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/${dir})
endforeach()
# 设置包含头文件的时候不用包含路径 end ****************************************************************************************

file(GLOB_RECURSE SRC_CPP ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE SRC_H ${CMAKE_CURRENT_LIST_DIR}/src/*.h)

find_package(Qt5 COMPONENTS Core DBus REQUIRED)
find_package(Dtk REQUIRED COMPONENTS Core)

add_executable(${BIN_NAME}
    ${SRC_CPP}
    ${SRC_H}
    src
)

target_include_directories(${BIN_NAME} PUBLIC
  Qt5::Core
  Qt5::DBus
  Dtk::Core
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt5::Core
  Qt5::DBus
  Dtk::Core
)

install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES com.deepin.SystemMonitorServer.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)

=== deepin-system-monitor-system-server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(BIN_NAME deepin-system-monitor-system-server)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

# 设置包含头文件的时候不用包含路径 begin ****************************************************************************************
MACRO(SUBDIRLIST result curdir)
  FILE(GLOB children RELATIVE ${curdir} ${curdir}/*)
  SET(dirlist "")
  FOREACH(child ${children})
    IF(IS_DIRECTORY ${curdir}/${child})
      LIST(APPEND dirlist ${child})
    ENDIF()
  ENDFOREACH()
  SET(${result} ${dirlist})
ENDMACRO()
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
SUBDIRLIST(dirs ${CMAKE_CURRENT_SOURCE_DIR}/src)
foreach(dir ${dirs})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/${dir})
endforeach()
# 设置包含头文件的时候不用包含路径 end ****************************************************************************************

file(GLOB_RECURSE SRC_CPP ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE SRC_H ${CMAKE_CURRENT_LIST_DIR}/src/*.h)

find_package(Qt5 COMPONENTS Core DBus REQUIRED)
find_package(PolkitQt5-1 REQUIRED)
find_package(Dtk REQUIRED COMPONENTS Core)

add_executable(${BIN_NAME}
    ${SRC_CPP}
    ${SRC_H}
)

target_include_directories(${BIN_NAME} PUBLIC
  Qt5::Core
  Qt5::DBus
  PolkitQt5-1::Agent
  Dtk::Core
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt5::Core
  Qt5::DBus
  PolkitQt5-1::Agent
  Dtk::Core
)

# Use deepin-service-manager mange DBus servicde
install(TARGETS ${BIN_NAME} DESTINATION /usr/lib/deepin-daemon/)
install(FILES ./misc/${BIN_NAME}.json DESTINATION share/deepin-service-manager/other/)
# DBus service and conf
install(FILES ./misc/org.deepin.SystemMonitorSystemServer.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/system-services)
install(FILES ./misc/org.deepin.SystemMonitorSystemServer.conf DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/system.d)
# Systemd
install(FILES ./misc/deepin-system-monitor-system-server.service DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system/)
# Polkit; Update translation
set(POLICY_FILE org.deepin.deepin-system-monitor-system-server.policy)
find_program(POLICY_TS_CONV deepin-policy-ts-convert REQUIRED)
add_custom_target(APP_POLICY_FILE_TEST
    ALL
    COMMAND ${POLICY_TS_CONV} ts2policy ${CMAKE_CURRENT_SOURCE_DIR}/misc/${POLICY_FILE} ${CMAKE_CURRENT_SOURCE_DIR}/translations/policy/ ${POLICY_FILE}.tmp
    COMMAND mv ${POLICY_FILE}.tmp ${CMAKE_CURRENT_SOURCE_DIR}/misc/${POLICY_FILE}
)
install(FILES ./misc/${POLICY_FILE} DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/actions)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(PROJECT_NAME deepin-system-monitor)
set(PROJECT_NAME_TEST
    ${PROJECT_NAME}-test)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
#set(CMAKE_AUTOUIC ON)

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_WIN32_THREADS_INIT 0)
set(CMAKE_USE_PTHREADS_INIT 1)
set(THREADS_PREFER_PTHREAD_FLAG ON)

ADD_COMPILE_OPTIONS(-fno-access-control)
add_definitions(-DENABLE_AUTO_UNIT_TEST)

set(APP_RES_ROOT assets)
set(APP_RESOURCES ../deepin-system-monitor-main/${APP_RES_ROOT}/${PROJECT_NAME}.qrc)
set(DESKTOP_FILE ${PROJECT_NAME}.desktop)
set(POLICY_FILE com.deepin.pkexec.${PROJECT_NAME}.policy)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)


#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wl,-Map=deepin-system-monitor-test.map")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wl,-Map=deepin-system-monitor-test.map")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "Release")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

configure_file(${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/environments.h.in ${CMAKE_CURRENT_BINARY_DIR}/environments.h @ONLY)

include(CheckIncludeFiles)
check_include_files ("sys/random.h" HAVE_SYS_RANDOM_H)
include(CheckSymbolExists)
check_symbol_exists(syscall "unistd.h" HAVE_SYS_CALL)
check_symbol_exists(SYS_getrandom "sys/syscall.h" HAVE_SYS_GETRANDOM)
configure_file(${CMAKE_HOME_DIRECTORY}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include(FindPkgConfig)

find_package(KF5Wayland)
find_package(Qt5 COMPONENTS Core REQUIRED)
find_package(Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Gui REQUIRED)
find_package(Qt5 COMPONENTS X11Extras REQUIRED)
find_package(Qt5 COMPONENTS DBus REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS LinguistTools REQUIRED)

find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)
find_library(LIB_PCAP NAMES pcap REQUIRED)
find_library(LIB_XCB NAMES xcb REQUIRED)
find_library(LIB_XEXT NAMES Xext REQUIRED)
find_library(LIB_ICCCM NAMES xcb-icccm REQUIRED)
find_package(ICU COMPONENTS i18n uc REQUIRED)

# For UT Test
find_package(GTest REQUIRED)
find_package(Qt5Test REQUIRED)
find_package(Threads REQUIRED)
include_directories(${GTEST_INCLUDE_DIRS})

pkg_search_module(LIB_NL3 REQUIRED libnl-3.0)
pkg_search_module(LIB_NL3_ROUTE REQUIRED libnl-route-3.0)
pkg_search_module(LIB_UDEV REQUIRED libudev)
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})
include_directories(${LIB_NL3_INCLUDE_DIRS})
include_directories(${LIB_NL3_ROUTE_INCLUDE_DIRS})
include_directories(${LIB_UDEV_INCLUDE_DIRS})
include_directories(${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main)
include_directories(${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui)
include_directories(${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/3rdparty)
include_directories(${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/3rdparty/include)
include_directories(${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/3rdparty/libsmartcols/src)



set(HPP_GLOBAL
    ${CMAKE_HOME_DIRECTORY}/config.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/environments.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/accessible.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/accessibledefine.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/application.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/stack_trace.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/cpu_monitor.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/memory_monitor.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/network_monitor.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_cpu_monitor.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_memory_monitor.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_network_monitor.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_disk_monitor.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/smooth_curve_generator.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/settings.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/detailwidgetmanager.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/dialog/systemprotectionsetting.h
)
set(CPP_GLOBAL
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/application.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/cpu_monitor.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/memory_monitor.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/network_monitor.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_cpu_monitor.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_memory_monitor.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_network_monitor.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/compact_disk_monitor.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/smooth_curve_generator.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/settings.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/detailwidgetmanager.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/dialog/systemprotectionsetting.cpp
)

set(HPP_COMMON
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/common.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/error_context.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/hash.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/han_latin.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/perf.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/base_thread.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/thread_manager.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/time_period.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/sample.h
)
set(CPP_COMMON
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/common.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/error_context.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/hash.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/han_latin.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/perf.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/thread_manager.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/common/time_period.cpp
)

set(HPP_DBUS
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/systemd1_manager_interface.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/systemd1_service_interface.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/systemd1_unit_interface.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/dbus_properties_interface.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/dbus_common.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/environment_file.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/unit_file_info.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/unit_info.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/dbusforsystemomonitorpluginservce.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/dbus_object.h
)
set(CPP_DBUS
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/environment_file.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/unit_file_info.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/unit_info.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/systemd1_manager_interface.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/systemd1_service_interface.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/systemd1_unit_interface.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/dbus_properties_interface.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/dbusforsystemomonitorpluginservce.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/dbus/dbus_object.cpp
)

set(HPP_MODEL
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/process_table_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/process_sort_filter_proxy_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/system_service_table_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/system_service_sort_filter_proxy_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_info_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_stat_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_list_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_list_sort_filter_proxy_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_info_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_stat_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_addr_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_info_sort_filter_proxy_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/block_dev_stat_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/block_dev_info_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/block_dev_info_sort_filter_proxy_model.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/model_manager.h
)
set(CPP_MODEL
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/system_service_table_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/system_service_sort_filter_proxy_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/process_table_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/process_sort_filter_proxy_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_info_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_stat_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_list_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/cpu_list_sort_filter_proxy_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_info_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_stat_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_addr_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/netif_info_sort_filter_proxy_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/block_dev_info_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/block_dev_stat_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/block_dev_info_sort_filter_proxy_model.cpp
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/model/model_manager.cpp
)

set(HPP_GUI
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/base/base_detail_item_delegate.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/base/base_table_view.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/base/base_item_delegate.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/base/base_header_view.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/base/base_detail_view_widget.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/base/base_commandlink_button.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/ui_common.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/toolbar.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/main_window.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/process_table_view.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/process_page_widget.h
    ${CMAKE_HOME_DIRECTORY}/${PROJECT_NAME}-main/gui/service_name_sub_input_dialog.h

=== deepin-system-monitor-main/3rdparty/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(untitled C)
message(${PROJECT_SOURCE_DIR})

include_directories(${PROJECT_SOURCE_DIR}/libsmartcols/src)
include_directories(${PROJECT_SOURCE_DIR}/include)
set(MARTCOLS
        libsmartcols/src/calculate.c
        libsmartcols/src/cell.c
        libsmartcols/src/column.c
        libsmartcols/src/grouping.c
        libsmartcols/src/init.c
        libsmartcols/src/iter.c
        libsmartcols/src/libsmartcols.h
        libsmartcols/src/line.c
        libsmartcols/src/print-api.c
        libsmartcols/src/print.c
        libsmartcols/src/smartcolsP.h
        libsmartcols/src/symbols.c
        libsmartcols/src/table.c
        libsmartcols/src/version.c
        libsmartcols/src/walk.c
        )
set(
        CFILE
        lscpu.h
        lscpu-arm.c
        lscpu-cpu.c
        lscpu-cputype.c
        lscpu-dmi.c
        lscpu-topology.c
        lscpu-virt.c
        cpuset.c
        path.c
        strutils.c
        buffer.c
        mbsalign.c
        color-names.c
        jsonwrt.c
        ttyutils.c
        c_strtod.c
        fileutils.c
)
set(HEADER
        include/all-io.h
        include/encode.h
        include/minix.h
        include/pty-session.h
        include/bitops.h
        include/env.h
        include/monotonic.h
        include/pwdutils.h
        include/blkdev.h
        include/exec_shell.h
        include/namespace.h
        include/randutils.h
        include/buffer.h
        include/exitcodes.h
        include/nls.h
        include/rpmatch.h
        include/canonicalize.h
        include/fileutils.h
        include/optutils.h
        include/selinux-utils.h
        include/caputils.h
        include/fuzz.h
        include/pager.h
        include/sha1.h
        include/carefulputc.h
        include/idcache.h
        include/partx.h
        include/signames.h
        include/cctype.h
        include/ismounted.h
        include/path.h
        include/statfs_magic.h
        include/c.h
        include/iso9660.h
        include/pathnames.h
        include/strutils.h
        include/closestream.h
        include/jsonwrt.h
        include/pidfd-utils.h
        include/strv.h
        include/color-names.h
        include/linux_version.h
        include/plymouth-ctrl.h
        include/swapheader.h
        include/colors.h
        include/list.h
        include/procutils.h
        include/swapprober.h
        include/cpuset.h
        include/loopdev.h
        include/pt-bsd.h
        include/sysfs.h
        include/crc32c.h
        include/mangle.h
        include/pt-gpt-partnames.h
        include/timer.h
        include/crc32.h
        include/match.h
        include/pt-mbr.h
        include/timeutils.h
        include/c_strtod.h
        include/mbsalign.h
        include/pt-mbr-partnames.h
        include/ttyutils.h
        include/debug.h
        include/mbsedit.h
        include/pt-sgi.h
        include/widechar.h
        include/debugobj.h
        include/md5.h
        include/pt-sun.h
        include/xalloc.h
        )

set(CMAKE_C_STANDARD 99)

add_executable(untitled lscpu.c ${MARTCOLS} ${HEADER} ${CFILE})

=== debian/changelog ===
deepin-system-monitor (6.0.23) unstable; urgency=medium

  * chore: 使用am启动deepin-system-monitor
  * feat: ddlog adaptation config

 -- fuleyi <fuleyi@uniontech.com>  Mon, 29 Jul 2024 17:17:27 +0800

deepin-system-monitor (6.0.21) unstable; urgency=medium

  * New version 6.0.21.

 -- shuaijie <shuaijie@uniontech.com>  Wed, 10 Jul 2024 14:41:00 +0800

deepin-system-monitor (6.0.20) unstable; urgency=medium

  * New version 6.0.20.

 -- shuaijie <shuaijie@uniontech.com>  Thu, 26 Jun 2024 16:18:12 +0800

deepin-system-monitor (6.0.19) unstable; urgency=medium

  * New version 6.0.19.

 -- shuaijie <shuaijie@uniontech.com>  Tue, 30 Apr 2024 10:44:12 +0800

deepin-system-monitor (6.0.18) unstable; urgency=medium

  * feat: Block the system monitor plugin.(Task: 30767)

 -- renbin <renbin@uniontech.com>  Wed, 10 Apr 2024 15:56:41 +0800

deepin-system-monitor (6.0.17) unstable; urgency=medium

  * fix: delay in reading system information in the plug-in (#325)
  * chore: Adapt blurEffectWidget with inner and outer borders
  * feat: Adapt taskbar icon activation status (#327) (Task: 331683)

 -- renbin <renbin@uniontech.com>  Wed, 27 Mar 2024 15:23:42 +0800

deepin-system-monitor (6.0.16) unstable; urgency=medium

  * New version 6.0.16.

 -- shuaijie <shuaijie@uniontech.com>  Thu, 13 Mar 2024 14:50:06 +0800

deepin-system-monitor (6.0.15) unstable; urgency=medium

  * New version 6.0.15.

 -- shuaijie <shuaijie@uniontech.com>  Fri, 01 Mar 2024 15:55:47 +0800

deepin-system-monitor (6.0.14) unstable; urgency=medium

  * New version 6.0.14.

 -- fengli <fengli@uniontech.com>  Tue, 27 Feb 2024 15:55:47 +0800

deepin-system-monitor (6.0.13) unstable; urgency=medium

  * fix some bugs.

 -- fengli <fengli@uniontech.com>  Wed, 21 Feb 2024 17:01:03 +0800

deepin-system-monitor (6.0.12) unstable; urgency=medium

  * fix: Adapt getWindowStates() interface(Bug: 235483)

 -- houchengqiu <houchengqiu@uniontech.com>  Wed, 17 Jan 2024 13:46:55 +0800

deepin-system-monitor (6.0.11) unstable; urgency=medium

  * feat: replace the plugin icon with the system icon
  * feat: adapt to new models

 -- fengli <fengli@uniontech.com>  Wed, 10 Jan 2024 11:47:17 +0800

deepin-system-monitor (6.0.10) unstable; urgency=medium

  * fix: The first time the system monitor display is set up in the control center taskbar, it needs to be clicked twice before the system monitor icon will be displayed in the taskbar

 -- fengli <fengli@uniontech.com>  Fri, 22 Dec 2023 15:20:59 +0800

deepin-system-monitor (6.0.9) unstable; urgency=medium

  * new version.

 -- shuaijie <shuaijie@uniontech.com>  Thu, 14 Nov 2023 10:08:10 +0800

deepin-system-monitor (6.0.8) unstable; urgency=medium

  * feat: 改造系统监视器服务
  * fix: 资源占用达到报警阈值时未弹出消息通知(Bug: 194991)
  * fix: dde接口适配
  * fix: 修复传输文件时，系统监视器不显示传速度(Bug: 163561)
  * fix: 修复1060末启动server
  * feat: 新增pgw判断
  * chore: Sync by https://github.com/linuxdeepin/.github/commit/559e91167d4919644f37bbcf123eb0651c1528ea(Influence: none)
  * fix: 修复在dde-dock中右键菜单系统监视器图标无法激活系统监视器窗口到顶层(Bug: 191373)
  * feat: hw机型判断适配dconfig(Task: 276433)
  * feat: hw机型判断适配dconfig(Task: 276433)
  * fix: 系统监视器占用资源过高优化
  * feat: merge branch chinalife
  * feat: 优化底层数据读取
  * fix: 插件功能回退
  * fix: V20、V23接口兼容
  * fix: 修改为通过QtDBus调用dde接口并兼容V20与V23接口变化
  * fix: 火狐浏览器进程的磁盘写入速率达到8EB/s(Bug: 212249)
  * fix: Can't pack v23 in obs
  * fix: deepin-system-monitor crashed(Issue: https://github.com/linuxdeepin/developer-center/issues/5592)
  * fix: 判断dde-dock版本，区分V23与V20插件实现

 -- YeShanShan <yeshanshan@deepin.org>  Mon, 11 Sep 2023 15:48:23 +0800

deepin-system-monitor (6.0.7) unstable; urgency=medium

  * new version.

 -- shuaijie <shuaijie@uniontech.com>  Fri, 12 May 2023 11:19:12 +0800

deepin-system-monitor (6.0.6) unstable; urgency=medium

  * New version 6.0.6

 -- wangyu <wangyu@uniontech.com>  Mon, 13 Mar 2023 15:41:21 +0800

deepin-system-monitor (6.0.5) unstable; urgency=medium

  *update version 

 -- liuzheng <liuzheng@uniontech.com>  Tue, 07 Feb 2023 15:24:57 +0800

deepin-system-monitor (6.0.4) unstable; urgency=medium

  * update version

 -- liuzheng <liuzheng@uniontech.com>  Mon, 16 Jan 2023 17:28:19 +0800

deepin-system-monitor (6.0.3) unstable; urgency=medium

  * New version 6.0.3

 -- wangyu <wangyu@uniontech.com>  Fri, 6 Jan 2023 10:52:18 +0800

deepin-system-monitor (6.0.2) unstable; urgency=medium

  * New version 6.0.2

 -- wangyu <wangyu@uniontech.com>  Tue, 6 Dec 2022 11:22:18 +0800

deepin-system-monitor (6.0.1) unstable; urgency=medium

  * New version 6.0.1

 -- wangyu <wangyu@uniontech.com>  Wed, 9 Nov 2022 10:03:18 +0800

=== debian/control ===
Source: deepin-system-monitor
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: 
 debhelper (>= 11), 
 cmake, 
 pkg-config, 
 qtbase5-dev, 
 qttools5-dev, 
 libdtkwidget-dev, 
 libxcb1-dev, 
 libqt5x11extras5-dev, 
 libxext-dev, 
 libpcap-dev, 
 qttools5-dev-tools, 
 libicu-dev, 
 deepin-gettext-tools, 
 libxcb-util0-dev, 
 libxcb-icccm4-dev, 
 libnl-3-dev, 
 libnl-route-3-dev, 
 libudev-dev, 
 libgsettings-qt-dev, 
 dde-dock-dev, 
 libgtest-dev, 
 libgmock-dev, 
 libdwayland-dev | libkf5wayland-dev,
 libwayland-dev,
 libpolkit-qt5-1-dev
Standards-Version: 3.9.8
Homepage: https://github.com/linuxdeepin/deepin-system-monitor

Package: deepin-system-monitor
Architecture: any
Depends: ${shlibs:Depends}, 
 ${misc:Depends}, 
 libcap2-bin, 
 libdwaylandclient5 | libkf5waylandclient5, 
 libdwaylandserver5 | libkf5waylandserver5,
 deepin-service-manager
Recommends: uos-reporter, deepin-event-log
Replaces: deepin-system-monitor-plugin
Description: A system monitor tool.
 System Monitor is a system tool monitoring and managing hardware load, program running and system services. It's capable to real-time monitor CPU status, memory footprint, and upload/download speed, manage system and application processes, search and force end processes as well.
